<%@include file="/libs/wcm/global.jsp"%>
<%@page contentType="text/html;charset=UTF-8"%>
<%@page import="com.day.cq.widget.HtmlLibraryManager"%>
<%@page import="com.day.cq.search.*, com.day.cq.search.result.*, com.day.cq.search.facets.*, com.day.cq.search.facets.buckets.*, java.util.*, javax.jcr.*, com.headwire.cq.reporting.services.*"%>
<%@page import="com.headwire.cloudwords.services.*,com.headwire.cloudwords.util.CloudwordsUtil, com.cloudwords.api.client.resources.*" %>
<%@ page import="com.headwire.cloudwords.services.CloudwordsService.ServiceException" %>
<html>
<head>
<title>Cloudwords Projects</title>
    <cq:includeClientLib categories="cq.wcm.edit"/>
    <script src="/etc/designs/cloudwords/clientlibs.js" type="text/javascript"></script>
    <script src="/libs/cq/ui/resources/cq-ui.js" type="text/javascript"></script>
    <link rel="stylesheet" type="text/css" href="/etc/designs/cloudwords/clientlibs.css" />
</head>
<body>
	<h2>Cloudwords Projects</h2>
<%
    HtmlLibraryManager htmlMgr = sling.getService(HtmlLibraryManager.class);
    if (htmlMgr != null) {
        htmlMgr.writeIncludes(slingRequest, out, "cq.widgets");
    }

    // Handle a Command if given
    String commandValue = request.getParameter( "cmd" );
    if( commandValue != null ) {
        if( "close".equals( commandValue ) ) {
            String deleteProjectName = request.getParameter( "project" );
            if( deleteProjectName != null ) {
                try {
                    CloudwordsProject cloudwordsProject = new CloudwordsProject( resourceResolver, deleteProjectName, false );
                    cloudwordsProject.retire();
                } catch( RepositoryException e ) {
                    // Ignore it for now
                }
            }
        }
        // Retirect back to the original Page
        String redirectURL = request.getRequestURI();
        response.sendRedirect(redirectURL);
    }
    CloudwordsService service = CloudwordsUtil.getService().getCloudwordsService();
    List<Project> projects;
    List<String> localProjectNames = new ArrayList<String>();
    Resource lBaseResource = resourceResolver.getResource( CloudwordsManager.BASE_PROJECT_PAGE_PATH );
    Iterator<Resource> ir = lBaseResource.getChildren().iterator();
    while( ir.hasNext() ) {
        Resource lCloudwordsProject = ir.next();
        if( !"jcr:content".equals( lCloudwordsProject.getName() ) ) {
            localProjectNames.add( lCloudwordsProject.getName() );
        }
    }
    try {
        projects = service.getOpenProjects();
%>
	<p>
	All current projects in your cloudwords account
	</p>

	<div>
	<p>
	<table>
    	<tr>
            <td>Name</td>
            <td>Status</td>
            <td>Bid Due</td>
            <td>Delivery Due</td>
            <td colspan="2">Commands</td>
        </tr>
	<%
	//CloudwordsCustomerClient client = new CloudwordsCustomerClient("https://api-stage.cloudwords.com", 1, "2986254e439f7fb5d47bdac1e8487aff2d5a5ec20c4b5e8483ed1b9300b6bc0d");
	//List<Project> projects = client.getOpenProjects();
    	if( projects != null ) {
        	for( int i = 0; i < projects.size(); i++ ) {
    %>
        <tr>
    <%
                Project project = projects.get(i);
                CloudwordsProject cloudwordsProject = null;
                String projectName = project.getName();
                boolean projectDefinitionFound = false;
                try {
                    cloudwordsProject = new CloudwordsProject( resourceResolver, projectName, false );
                    projectDefinitionFound = true;
                    localProjectNames.remove( projectName );
                } catch( PathNotFoundException e ) {
                    // Ignore it
                }
                if( projectDefinitionFound ) {
    %>
            <td><a href="/etc/cloudwords/projects/<%= projectName %>.html"><%= projectName %></a> </td>
    <%
                } else {
    %>
            <td><%= projectName %> (No Local Project Info Available)</td>
    <%
                }
    %>
            <td><%= project.getStatus().getDisplay() %></td>
            <td><%= project.getBidDueDate() %></td>
            <td><%= project.getDeliveryDueDate() %></td>
<%
                if( projectDefinitionFound ) {
%>
            <td><a href="/etc/cloudwords/projects.html?project=<%= projectName %>&cmd=close"><button>close</button></a></td>
<%
            } else {
%>
            <td></td>
<%
            }
%>
            <td><a href="<%= CloudwordsUtil.getCloudwordsUrl() %>/cust.htm#project/<%= project.getId() %>" target="_blank"><button>view on cw</button></a></td>
        </tr>
    <%
            }
        }
        for( String projectName: localProjectNames ) {
    %>
        <tr>
            <%
                CloudwordsProject cloudwordsProject = new CloudwordsProject( resourceResolver, projectName, false );
            %>
            <td><a href="/etc/cloudwords/projects/<%= projectName %>.html"><%= projectName %></a> (No CW Project available)</td>
            <td></td>
            <td></td>
            <td></td>
            <td><a href="/etc/cloudwords/projects.html?project=<%= projectName %>&cmd=close"><button>close</button></a></td>
            <td></td>
        </tr>
        <%
        }
	%>
	
	</table>
	</p>
	</div>	
	
	<div>
		<p><a href="/etc/cloudwords/translationselector.html">Create new project</a></p>
	</div>
<%
    } catch( ServiceException e ) {
%>
    <h3>Failure</h3>
    <p>Could not contact Cloudwords in order to view the List of Projects. Please try again later.</p>
<%
    }
%>
</body>
</html>